# Black Widgets For Elementor

**Contributors:** skalanter, modernaweb \
**Donate link:** http://modernaweb.net/ \
**Tags:** page builder, editor, elementor widgets, elementor addon, typography \
**Stable tag:** 1.3.6 \
**Requires at least:** 5.3 \
**Tested up to:** 6.6 \
**Requires PHP:** 7.4 \
**License:** GPLv3 or later \
**License URI:** https://www.gnu.org/licenses/gpl-3.0.html

Free add-on for Elementor! With this add-on, you can add more visual effects and improve your website's user experience. ✌


## Description


Black Widgets is a free add-on for Elementor; with this plugin, you can create unique elements with the ability to customize your website.

We will add more widgets with more and more styles that may surprise you in the future; for now, add black widgets to your WordPress, and don't miss future updates.

[WPHive Review](https://wphive.com/plugins/black-widgets/)


### Create your own styles

✔️ 21 Widgets
⚡ An Awesome Typography
⚡ Great Animate with AnimeJS and GSAP
⚡ CSS Transform(2D & 3D CSS Styles)
⚡ Scroll Trigger(with CDN)

### ✹ Dsgn

Dsgn is a simple way to start a website easily, quickly, and free. This is Free & + Fresh Templates Design for Elementor and Black Widgets.

[Dsgn Templates](https://modernaweb.net/dsgn/)
[Our Solutions](https://modernaweb.net/dsgn/solutions/)

— Enjoy 😉

[Black Widgets Demo](https://modernaweb.net/black-widgets/)

### Available Widgets

*   [Black Title](https://modernaweb.net/black-widgets/all-widgets/black-title/)
*   [Black Button](https://modernaweb.net/black-widgets/all-widgets/black-button/)
*   [Black Image Pro](https://modernaweb.net/black-widgets/all-widgets/black-image/)
*   [Black Flip Box](https://modernaweb.net/black-widgets/all-widgets/black-flip-box/)
*   [Black Title Animate](https://modernaweb.net/black-widgets/all-widgets/black-title-animate/)
*   [Black Magic Link](https://modernaweb.net/black-widgets/all-widgets/black-magic-link/)
*   [Black Drop Cap](https://modernaweb.net/black-widgets/all-widgets/black-dropcap/)
*   [Black Fade](https://modernaweb.net/black-widgets/all-widgets/black-fade/)
*   [Black Alert](https://modernaweb.net/black-widgets/all-widgets/black-alert/)
*   [Black Icon](https://modernaweb.net/black-widgets/all-widgets/black-icon/)
*   [Black List](https://modernaweb.net/black-widgets/all-widgets/black-list/)
*   [Black Social Links](https://modernaweb.net/black-widgets/all-widgets/black-social-links/)
*   [Black Icon Box Pro](https://modernaweb.net/black-widgets/all-widgets/black-icon-box-pro/)
*   [Black Call to Action](https://modernaweb.net/black-widgets/all-widgets/black-call-to-action/)
*   [Black Blockquote](https://modernaweb.net/black-widgets/all-widgets/black-blockquote/)
*   [Black Typography(for experts)](https://modernaweb.net/black-widgets/all-widgets/black-typography/)
*   [Black Box](https://modernaweb.net/black-widgets/all-widgets/black-box/)
*   [Black Flat Nav(menu)](https://modernaweb.net/black-widgets/all-widgets/black-flat-nav/)
*   [Black Sentence](https://modernaweb.net/black-widgets/all-widgets/black-sentence/)
*   [Black Trigger(for experts)](https://modernaweb.net/black-widgets/all-widgets/black-trigger/)
*   [Black Horizontal(for experts)](https://modernaweb.net/black-widgets/all-widgets/black-horizontal/)



### Features

- [Builder Tools By Elementor](https://modernaweb.net/black-widgets/features/builder-tools/)
- [Typography](https://modernaweb.net/black-widgets/features/typography/)
- [GSAP Animate](https://modernaweb.net/black-widgets/features/gsap-animate/)
- [What's New](https://modernaweb.net/black-widgets/support/whats-new/)


### Support

If you found an issue or have a new suggestion, contact us: [ **modernawebdesign@gmail.com** ](mailto:modernawebdesign@gmail.com)

- [Contact Us](https://modernaweb.net/contact/)
- [Solutions](https://modernaweb.net/black-widgets/support/solutions/)
- [Documentation](https://modernaweb.net/black-widgets/features/documentation/)
- [Get Creative](https://modernaweb.net/black-widgets/support/get-creative/)

## Upgrade Notice

WordPress 5.3+


## Installation

1. Upload the entire `black-widgets` folder to the `/wp-content/plugins/` directory.
2. Activate the plugin through the **Plugins** screen (Plugins > Installed Plugins).
**Note:** You will find **Widgets** on Elementor page builder staging environment.


## Screenshots

### 1. Black Widgets Screenshot 1

![Black Widgets Screenshot 1](https://ps.w.org/black-widgets/assets/screenshot-1.png)

### 2. Black Widgets Screenshot 2

![Black Widgets Screenshot 2](https://ps.w.org/black-widgets/assets/screenshot-2.png)

### 3. Black Widgets Screenshot 3

![Black Widgets Screenshot 3](https://ps.w.org/black-widgets/assets/screenshot-3.png)

### 4. Black Widgets Screenshot 4

![Black Widgets Screenshot 4](https://ps.w.org/black-widgets/assets/screenshot-4.png)

### 5. Black Widgets Screenshot 5

![Black Widgets Screenshot 5](https://ps.w.org/black-widgets/assets/screenshot-5.png)

### 6. Black Widgets Screenshot 6

![Black Widgets Screenshot 6](https://ps.w.org/black-widgets/assets/screenshot-6.png)



## Changelog

### 1.3.6 — 2024-07-19

- Added: SVG size and color style for Black Icon Box Pro
- Fixed: Cross-site scripting (XSS) vulnerability in all widgets; Thanks to Patchstack.

### 1.3.5 — 2024-03-03

- Compatibility: Elementor v3.19 and all experiments and features
- Added: Width option for Black Image Pro
- Added: Blur option in the box settings for Black Image Pro, Black Button, Black Title, Black Alert, Black Icon Box Pro
- Added: A general class for for blur(.bw-blur) for columns and extra margin-removal(.no-margin) for all widgets
- Added: An alert with link above all widgets in the content section
- Improved: Added some esc_html__ for text inputs for security reasons
- Fixed: Some alignment issue on widgets

### 1.3.4 — 2023-11-05

- Compatibility: WordPress v6.4
- Compatibility: Elementor v3.17
- Updated: Anime.js 
- Changed: Some widget icons
- Improved: Fade animate
- Fixed: Some minor issue

### 1.3.3 — 2023-08-08

- Compatibility: WordPress v6.3
- Compatibility: Elementor v3.15
- Compatibility: Enabled options for Experiments and Features in Elementor
- Added: New Option: "Sentence Alignment" for Black Sentence
- Added: New Feature: "On Scroll" for Black Typography
- Removed: The StyleFix 1.0.3 & PrefixFree library from Elementor environment
- Fixed: Default trigger for image pro
- Fixed: Some minor issue

### 1.3.2 — 2023-04-01

- Compatibility: WordPress v6.2
- Compatibility: Elementor v3.12
- Added: Box style and positioning for Black Icon Box Widget
- Fixed: Some minor issue

### 1.3.1 — 2023-03-04

- Compatibility: WordPress v6.1
- Compatibility: Elementor v3.11
- Added: New widget: Black Sentence
- Improved: First set-up notice related to GSAP
- Fixed: PHP Deprecated on the "register_widget_type" hook
- Fixed: Some minor issue

### 1.3.0 — 2022-08-14

- Compatibility: WordPress v6.0
- Compatibility: Elementor v3.7
- Added: New widget: Black Flat Nav
- Added: Custom Black Button Styles
- Added: Black Button Alignment(s)
- Added: Custom Button Styling
- Added: Image Trigger with GSAP
- Added: Link item to Black List
- Added: 4 direction for the Black Fade Image
- Improved: Dark Mode
- Removed: Scheme from some widgets
- Fixed: Some issues on UI and UX of the Black Magic Links
- Fixed: Some issues on the Black Flip Box widget
- Fixed: Some issues on the Black Typography widget
- Fixed: Some minor issue

### 1.2.6 — 2022-01-31

- Compatibility: WordPress v5.9
- Compatibility: Elementor v3.5
- Added: An option for movements on typography widget

### 1.2.5 — 2021-10-17

- Compatibility: Elementor Pro
- Added: An option to use GSAP CDN (for experts)
- Added: An option to use ScrollTrigger CDN (for experts)
- Added: An option to use Tween CDN (for experts)
- Added: An option to use Timeline CDN (for experts)
- Added: New Widget: Black Trigger
- Added: New Widget: Black Horizontal
- Added: An option to create movements image (for experts)
- Fixed: Font icons on widgets

### 1.2.0 — 2021-08-04

- Compatibility: WordPress v5.8.0
- Compatibility: Elementor v3.3.0
- Added: New widget: Black Box

### 1.1.5 — 2021-04-29

- Compatibility: WordPress v5.7.0
- Compatibility: Elementor v3.2.0
- Added: New widget: Black Typography
- Improved: Compatibility with Elementor v3.0.0
- Improved: Dark Mode
- Fixed: Some minor issue

### 1.1.0 — 2020-09-10

- Compatibility: WordPress v5.5.0
- Compatibility: Elementor v3.0.0
- Compatibility: Safari, Chrome, Firefox Browsers
- Added: Ability to add transform CSS for BW Image and BW Image Fade widgets
- Added: Ability to set Mouse Cursor for BW Image and BW Image Fade widgets
- Added: Setting Styles
- Added: README.md file for Github repository
- Improved: All Widgets
- Checked: BW Functionality
- Checked: BW Security scan
- Fixed: Responsive issue on BW Call To Action widget
- Fixed: Some minor issue

### 1.0.5 — 2020-06-21

- Added: Settings page
- Added: Elementor environment dark mode
- Added: New widget: Black Blockquote
- Fixed: Some minor issue

### 1.0.2 — 2020-05-30

- Added: Namespace to the plugin
- Changed: BW Classes to BLACK_WIDGETS
- Changed: bw text domain to blackwidgets
- Fixed: Some minor issue

### 1.0.1 — 2020-05-28

- Fixed: Some minor issue

### 1.0.0 — 2020-05-23

- Initial release.


## Frequently Asked Questions

### How can I install Black Widgets?
To install this plugin head over to [this link](https://bit.ly/2BcILYB).

### What I do after install and activate the add-on?
After activating the add-on, you redirect to [this page](https://i.postimg.cc/d3bGS6wj/image.png), then, you can go to Elementor page builder staging environment and just find the "Black Widgets" tab on the widget side.

### Can I use Black Widgets without Elementor?
Unfortunately not, it's not possible, but I have good news, you can use Elementor with your page builder together(mostly).

### How can I see Black Widgets' road map?
For now, the road map is private. But we'll publish it for you.
